/*
    JSiteMap 0.9.0 - A Java Site Map Generator
    Copyright (C) 2003 Pierre Blanc
    Pierre Blanc: blanc_teutoburgo@yahoo.it
    http://www.site-map.tk
    http://it.geocities.com/teutoburgo

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    or go to      http://www.gnu.org/copyleft/gpl.html
*/

package tk.teutoburgo.jsitemap;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class PopUp extends Frame
			  implements ActionListener {
    boolean inAnApplet = true, closeOk=true;
	int n;
	private TextArea textArea;
    String newline;
	Panel valuePanel=new Panel(), optionPanel=new Panel(),
			nPanel=new Panel();
	GridLayout grid;
	ScrollPane sp = new ScrollPane();
	Button save=new Button("Save"), defaults=new Button("Restore default values");
	Vector options;
	Label labelStatus=new Label(".                                         .");
	Util util=new Util();
    public PopUp(Vector options) {
		newline = System.getProperty("line.separator");
		nPanel.add(save);
		save.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				buttonSave_mouseClicked(e);
			}
			});
		defaults.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				buttonDefaults_mouseClicked(e);
			}
			});
		nPanel.add(defaults);
		nPanel.add(labelStatus);
		n=options.size();
		grid = new GridLayout(n,2);
		optionPanel.setLayout(grid);
		sp.add(optionPanel);
		this.setLayout(new BorderLayout());
		this.add(sp, BorderLayout.CENTER);
		this.add(nPanel, BorderLayout.NORTH);
		loadOptions(options);
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
			if (inAnApplet) {
				setVisible(false);
				dispose();
			} else {
				System.exit(0);
			}
			}
		});

	}

    public void loadOptions(Vector options) {
		optionPanel.removeAll();
		this.options=options;
		for(int i=0; i<n; i++){
			String[] option=(String[])options.elementAt(i);
			String type=option[2];
			optionPanel.add(new Label(option[0]),2*i);
			if(type.equals(JSiteMapApplet.STRING))
				optionPanel.add(new TextField(option[1],10),2*i+1);
			else if(type.equals(JSiteMapApplet.NUMBER)){
				optionPanel.add(new TextField(option[1],10),2*i+1);
			} else{
				Checkbox check=new Checkbox();
				if(option[1].equals("true"))
					check.setState(true);
				optionPanel.add(check,2*i+1);
			}
		}
		optionPanel.repaint();
		optionPanel.validate();
    }

    void buttonSave_mouseClicked(MouseEvent e) {
		try{
		closeOk=true;
		FileInputStream fis=new FileInputStream(
                    "./config/menuOptions.cfg");
		Properties p=new Properties();
		int n=optionPanel.getComponentCount()/2;
		for(int i=0; i<n; i++){
			Label label=(Label)(optionPanel.getComponent(2*i));
			String[] option=(String[])options.elementAt(i);
			String type=option[2];
			//System.out.println("+ "+i+" ++"+option[0]+" "+type);
			Component iComp=optionPanel.getComponent(2*i+1);
			if(type.equals(JSiteMapApplet.BOOLEAN)){
				Checkbox cb=(Checkbox)(iComp);
				if(cb.getState())
					option[1]="true";
				else
					option[1]="false";
				options.setElementAt(option,i);
			} else if(type.equals(JSiteMapApplet.STRING)){
				TextField tf=(TextField)(iComp);
				option[1]="\""+tf.getText()+"\"";
				//System.out.println("VALUE="+option[1]);
			} else if(type.equals(JSiteMapApplet.NUMBER)){
				try{
					TextField tf=(TextField)(iComp);
					Integer.parseInt(tf.getText());
					option[1]=tf.getText();
				}catch (NumberFormatException nfe){
					labelStatus.setText("Error in a numeric field!");
					closeOk=false;
				}
			}
			p.setProperty(option[0],option[1]);
		}
		fis.close();
		FileOutputStream fos=new FileOutputStream(
                    "./config/menuOptions.cfg");
		p.store(fos,null);
		if(closeOk)
			this.setVisible(false);
	}catch(Exception fnfe){
		fnfe.printStackTrace();
	}
	}

	void buttonDefaults_mouseClicked(MouseEvent e) {
		try{
		options=util.readOptions("./config/defaultValues.cfg");
		loadOptions(options);
		}catch(Exception fnfe){
			fnfe.printStackTrace();
		}
	}

    public void actionPerformed(ActionEvent event) {
    }

}
